﻿Module Module1

    Private mstrMenuChoice As String

    Sub Main()

        ShowMenu()

        Do
            Select Case mstrMenuChoice
                Case "1"
                    Crash()
                Case "2"
                    HandleGeneralError()
                Case "3"
                    CancelErrorHandling()
                Case "4"
                    HandleSpecificError()
                Case "5"
                    IgnoreError()
                Case "6"
                    End
                Case Else
                    Console.WriteLine()
                    Console.Write("INVALID CHOICE. Enter the number corresponding to your selection: ")
                    mstrMenuChoice = Console.ReadLine
            End Select

        Loop


    End Sub

    Private Sub ShowMenu()

        Console.Clear()
        Console.WriteLine("*** 'OLD SCHOOL' ERROR HANDLING DEMO ***")
        Console.WriteLine()
        Console.WriteLine("Select an item from the list below:")
        Console.WriteLine()
        Console.WriteLine("1. Crash")
        Console.WriteLine("2. Handle General Error")
        Console.WriteLine("3. Cancel Error Handling")
        Console.WriteLine("4. Handle Specific Error")
        Console.WriteLine("5. Ignore Error")
        Console.WriteLine("6. Exit")

        Console.WriteLine()
        Console.Write("Enter the number corresponding to your selection: ")
        mstrMenuChoice = Console.ReadLine

    End Sub

    Private Sub Crash()

        FileOpen(1, "E:\JUNK.TXT", OpenMode.Input)
        Console.WriteLine("File was opened successfully.")
        FileClose(1)

        Console.WriteLine()
        Console.WriteLine("Press Enter to Return to Menu.")
        Console.ReadLine()
        ShowMenu()

    End Sub

    Private Sub HandleGeneralError()

        On Error GoTo GeneralErrorHandler

        FileOpen(1, "E:\JUNK.TXT", OpenMode.Input)
        Console.WriteLine("File was opened successfully.")
        FileClose(1)

ReturnToMenu:
        Console.WriteLine()
        Console.WriteLine("Press Enter to Return to Menu.")
        Console.ReadLine()
        ShowMenu()
        Exit Sub

GeneralErrorHandler:
        Console.WriteLine()
        Console.WriteLine("The following error has occurred: " & vbNewLine _
                          & "Error # " & Err.Number & " - " & Err.Description)
        GoTo ReturnToMenu

    End Sub

    Private Sub CancelErrorHandling()

        On Error GoTo GeneralErrorHandler

        'cancel above error handler
        On Error GoTo 0

        FileOpen(1, "E:\JUNK.TXT", OpenMode.Input)
        Console.WriteLine("File was opened successfully.")
        FileClose(1)

ReturnToMenu:
        Console.WriteLine()
        Console.WriteLine("Press Enter to Return to Menu.")
        Console.ReadLine()
        ShowMenu()
        Exit Sub

GeneralErrorHandler:
        Console.WriteLine()
        Console.WriteLine("The following error has occurred: " & vbNewLine _
                          & "Error # " & Err.Number & " - " & Err.Description)
        GoTo ReturnToMenu

    End Sub

    Private Sub HandleSpecificError()

        On Error Resume Next

        FileOpen(1, "E:\JUNK.TXT", OpenMode.Input)

        Select Case Err.Number
            Case 0
                Console.WriteLine("File was opened successfully.")
                FileClose(1)
            Case 53
                Console.WriteLine()
                Console.WriteLine("Error: File 'JUNK.TXT' was not found.")
            Case 76
                Console.WriteLine()
                Console.WriteLine("Error: Drive not found.")
            Case Else
                Console.WriteLine()
                Console.WriteLine("The following error has occurred: " & vbNewLine _
                                  & "Error # " & Err.Number & " - " & Err.Description)
        End Select

        Console.WriteLine()
        Console.WriteLine("Press Enter to Return to Menu.")
        Console.ReadLine()
        ShowMenu()

    End Sub

    Private Sub IgnoreError()

        On Error Resume Next

        FileOpen(1, "E:\JUNK.TXT", OpenMode.Input)
        FileClose(1)

        Console.WriteLine()
        Console.WriteLine("We don't know if the file was opened successfully.")

        Console.WriteLine()
        Console.WriteLine("Press Enter to Return to Menu.")
        Console.ReadLine()
        ShowMenu()

    End Sub

End Module
